.586
.model flat,stdcall
option casemap:none

	include	windows.inc
	include user32.inc
	include kernel32.inc
	include advapi32.inc
	include wsock32.inc
	include	comctl32.inc	;for IP control
	include winmm.inc	;for playsound
	
	includelib user32.lib
	includelib kernel32.lib
	includelib advapi32.lib
	includelib wsock32.lib
	includelib comctl32.lib
	includelib winmm.lib
	
DEBUG_BUILD	EQU	1

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD


.DATA
	wnd_classname_sz	db "ChatEugen_WndClass",0
	wnd_name_sz		db "Chat Window",0
	
	username_sz_default	db	"User",0
	
.DATA?
	
	hInstance	HINSTANCE	?
	cmdline_psz	LPSTR		?
	
ONLINE_HOST	EQU	0
ONLINE_REMOTE	EQU	1
	online_mode	DD	?
	
USER_NAME_MAXSIZE	EQU	512
	username_psz	dd	?
	
	port		dd	?	;connection port
	
	ip		dd	?
	
SZ1_SIZEMAX	EQU	512
	psz1		dd	?	;generic for testing
	
	psz_exe		dd	?
	psz_folder	dd	?
	
	snd_msg_p	dd	?	;pointer to sound played when a msg is received and dlg is not active
	
	hfile		dd	?
	bytes_read	dd	?
	
	icc		INITCOMMONCONTROLSEX	<?>
.CODE


include	Chat.inc

;----------- utils -----------
include .\utils\dwtoa.asm
include	.\utils\outdbg.asm
include .\utils\strings.asm
include .\utils\mem.asm
include .\utils\get_exe_folder.asm

;---------- main network ---------
include network.asm

;--------- dialogs callback + some specific network ------
include Dlg_Online.asm
include Dlg_Chat.asm
include Dlg_Connecting.asm

; ---------------------------------------------------------------------------


start:
	mOS "================ START ==================="
	
	invoke	GetModuleHandle, NULL
	mov	[hInstance],eax
	
	call	GetCommandLine
	mov	[cmdline_psz],eax
	
	mov	[icc.dwSize],size INITCOMMONCONTROLSEX
	mov	[icc.dwICC],ICC_INTERNET_CLASSES
	invoke	InitCommonControlsEx,offset icc
	
	
;setup default values
	mov	[online_mode],ONLINE_HOST	;later from command line/ini file :)
	mov	[port],PORT_DEFAULT
	mov	[ip],IP_DEFAULT
	
	
;alloc memory for almost all needed global buffers
	invoke	GlobalAlloc,GMEM_FIXED + GMEM_ZEROINIT,\
		USER_NAME_MAXSIZE+SZ1_SIZEMAX+NET_BUFF_SIZE*2+MAX_PATH*2
	mov	[username_psz],eax
	add	eax,USER_NAME_MAXSIZE
	
	mov	[psz1],eax
	add	eax,SZ1_SIZEMAX
	
	mov	[send_buff_psz],eax
	add	eax,NET_BUFF_SIZE
	
	mov	[recv_buff_psz],eax
	add	eax,NET_BUFF_SIZE
	
	mov	[psz_exe],eax
	add	eax,MAX_PATH
	
	mov	[psz_folder],eax
	add	eax,MAX_PATH
	
;make sure current directoy is the exe directory
	invoke	GetModuleFileName,[hInstance],[psz_exe],MAX_PATH
	invoke	Get_Folder_From_Exe,[psz_exe],[psz_folder]
	invoke	SetCurrentDirectory,[psz_folder]
	
	
	
;load msg sound in memory
	invoke	CreateFileA,mSZ("pop1.wav"),GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	.IF	eax!=INVALID_HANDLE_VALUE
		mov	[hfile],eax
		invoke	GetFileSize,[hfile],0
		push	eax
		invoke	GlobalAlloc,GPTR or GMEM_SHARE,eax
		mov	[snd_msg_p],eax
		pop	ebx
		invoke	ReadFile,[hfile],eax,ebx,offset bytes_read,0
		invoke	CloseHandle,[hfile]
	.ENDIF
	
	
;all network initializations
	call	Net_Init
	
	
;	call	WinMain_Setup
	
	
	
Get_Online:
	invoke	DialogBoxParam,[hInstance],IDD_ONLINE,0,offset Online_Dlg_Callback,0
	cmp	eax,ONLINE_DLG_RESULT_EXIT
	jz	Exit
	
Connecting:
	invoke	DialogBoxParam,[hInstance],IDD_CONNECTING,0,offset Connecting_Dlg_Callback,0
	cmp	eax,CONNECTING_DLG_RESULT_ABORT
	jz	Get_Online
	
	
	
Start_Chat:
	invoke	DialogBoxParam,[hInstance],IDD_CHAT,0,offset Chat_Dlg_Callback,0
	
	jmp	Get_Online
	
	
Exit:
	
	call	Net_Cleanup
	
	invoke	GlobalFree,[username_psz]
	invoke	GlobalFree,[snd_msg_p]
	
	invoke	ExitProcess,0


;********************************************
; end on known Universe
; beyond this point lies the great unknown
; (the PC should never reach this point :D)
;*******************************************
	
	jmp	$


WinMain_Setup PROC
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   [wc.cbSize],SIZEOF WNDCLASSEX
	mov   [wc.style], CS_HREDRAW or CS_VREDRAW
	mov   [wc.lpfnWndProc], OFFSET WndProc
	mov   [wc.cbClsExtra],NULL
	mov   [wc.cbWndExtra],NULL
	push  [hInstance]
	pop   [wc.hInstance]
	mov   [wc.hbrBackground],COLOR_BTNFACE+1
	mov   [wc.lpszMenuName],NULL
	mov   [wc.lpszClassName],OFFSET wnd_classname_sz
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   [wc.hIcon],eax
	mov   [wc.hIconSm],eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   [wc.hCursor],eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR wnd_classname_sz,ADDR wnd_name_sz,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           [hInstance],NULL
	mov   [hwnd],eax
	
	invoke ShowWindow, [hwnd],SW_SHOWNORMAL
	invoke UpdateWindow, [hwnd]
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,[msg.wParam]
ret
WinMain_Setup ENDP

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		;
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
ret
WndProc ENDP


end start
