
;CHAT_DLG_MIN_HEIGHT	EQU	436
;CHAT_DLG_MIN_WIDTH	EQU	460
.DATA
; -- initial coords of dlg to use as min size ---
	chat_dlg_min_dx		dd	?
	chat_dlg_min_dy		dd	?
; -- initial coords of controls that move when the dlg is resized ---
	chat_dlg_edit_log_x	dd	?
	chat_dlg_edit_log_y	dd	?
	chat_dlg_edit_log_dx	dd	?
	chat_dlg_edit_log_dy	dd	?
	chat_dlg_edit_msg_x	dd	?
	chat_dlg_edit_msg_y	dd	?
	chat_dlg_edit_msg_dx	dd	?
	chat_dlg_edit_msg_dy	dd	?
	chat_dlg_btn_talk_x	dd	?
	chat_dlg_btn_talk_y	dd	?
	chat_dlg_btn_talk_dx	dd	?
	chat_dlg_btn_talk_dy	dd	?
	rect1			RECT	<?>
	rect2			RECT	<?>
.CODE

Chat_Dlg_Add_To_Log 	PROTO :DWORD,:DWORD,:DWORD
Chat_Dlg_Network_Handle PROTO :DWORD,:DWORD


Chat_Dlg_Callback PROC USES EBX EDI ESI EBP a_hdlg,a_msg,a_wparam,a_lparam:DWORD
	LOCAL	l_psz:DWORD,l_hedit_msg,l_msg_len,l_hedit:DWORD
	LOCAL	l_dx,l_dy:DWORD
	
	mov	eax,[a_msg]
	
	cmp	eax,WM_CLOSE
	jz	@@close
	cmp	eax,WM_INITDIALOG
	jz	@@init
	cmp	eax,WM_COMMAND
	jz	@@command
	cmp	eax,WM_KEYUP
	jz	@@key_up

	cmp	eax,WM_GETMINMAXINFO
	jz	@@minmax		;limit min and max sizes
	cmp	eax,WM_WINDOWPOSCHANGED
	jz	@@pos_changed
	
	
	cmp	eax,WM_MY_NET_MSG
	jz	@@network
	
	xor	eax,eax
ret


@@close:
	call	Net_Close_Sockets
	invoke	EndDialog,[a_hdlg],0
ret

;------ limit window size -------
@@minmax:
	mov	esi,[a_lparam]
	
	mov	eax,[chat_dlg_min_dx]
	mov	edx,[chat_dlg_min_dy]
	mov	[esi+MINMAXINFO.ptMinTrackSize.x],eax
	mov	[esi+MINMAXINFO.ptMinTrackSize.y],edx
	
	xor	eax,eax
ret
;------- size or position changed -----------------
@@pos_changed:
	
	mov	esi,[a_lparam]
	
	mov	eax,[esi+WINDOWPOS.lx]
	or	eax,[esi+WINDOWPOS.cy]
	jz	@@end_pos_changed
	
;compute how much the window has been resized
	mov	eax,[esi+WINDOWPOS.lx]
	sub	eax,[chat_dlg_min_dx]
	mov	[l_dx],eax
	mov	eax,[esi+WINDOWPOS.cy]
	sub	eax,[chat_dlg_min_dy]
	mov	[l_dy],eax
	
;adjust log window accordingly - keep top-left
	invoke	GetDlgItem,[a_hdlg],IDC_CHAT_EDIT_LOG
	mov	[l_hedit],eax
	
	mov	eax,[chat_dlg_edit_log_dx]
	mov	edx,[chat_dlg_edit_log_dy]
	add	eax,[l_dx]
	add	edx,[l_dy]
	invoke	MoveWindow,[l_hedit],[chat_dlg_edit_log_x],[chat_dlg_edit_log_y],eax,edx,TRUE
	
;adjust msg window accordingly - keep bottom-left
	invoke	GetDlgItem,[a_hdlg],IDC_CHAT_EDIT_MSG
	mov	[l_hedit],eax
	
	mov	eax,[chat_dlg_edit_msg_dx]
	add	eax,[l_dx]
	
	mov	edx,[chat_dlg_edit_msg_y]
	add	edx,[l_dy]
	invoke	MoveWindow,[l_hedit],[chat_dlg_edit_log_x],edx,eax,[chat_dlg_edit_msg_dy],TRUE
	
	
;adjust btn talk accordingly - keep bottom-right
	invoke	GetDlgItem,[a_hdlg],IDC_CHAT_BTN_TALK
	mov	[l_hedit],eax
	
	mov	eax,[chat_dlg_btn_talk_x]
	mov	edx,[chat_dlg_btn_talk_y]
	add	eax,[l_dx]
	add	edx,[l_dy]
	
	invoke	MoveWindow,[l_hedit],eax,edx,[chat_dlg_btn_talk_dx],[chat_dlg_btn_talk_dy],TRUE
	
	
	
@@end_pos_changed:
	xor	eax,eax
ret
	
	
	
;-----------------------------------------------------
;
; initialize the dialog:
; -set radio btn
;-----------------------------------------------------

@@init:
	
;set caption
	invoke	GetWindowText,[a_hdlg],[psz1],SZ1_SIZEMAX-32
	add	eax,[psz1]
	mov	[l_psz],eax
	
	mov	WORD PTR [eax],"( "
	add	eax,2
	mov	[l_psz],eax
	
	.IF	[online_mode]==ONLINE_HOST
		mov	edx,offset sz_host
	.ELSE
		mov	edx,offset sz_client
	.ENDIF
	
	invoke	Str_Copy,edx,eax
	add	eax,[l_psz]
	mov	[l_psz],eax
	
	mov	WORD PTR [eax]," )"
	add	eax,2
	mov	[l_psz],eax
	
	invoke	Str_Copy,[username_psz],eax
	add	eax,[l_psz]
	mov	[l_psz],eax
	
	invoke	SetWindowText,[a_hdlg],[psz1]
	
	
;set network notifications to this window
	invoke	WSAAsyncSelect,[hsocket],[a_hdlg],WM_MY_NET_MSG,\
			FD_ACCEPT + FD_CONNECT + FD_CLOSE + FD_READ + FD_WRITE
	.IF	eax==SOCKET_ERROR
		call	WSAGetLastError
		mNet_OutSVD eax,"Chat_Dlg_Callback-WM_INITDIALOG: WSAAsyncSelect error="
		jmp	@@end_init
	.ENDIF
	mNet_OS "Chat_Dlg_Callback-WM_INITDIALOG: WSAAsyncSelect succes"
	
	
;memo initial size of dlg to use as min size when dlg is resized
	invoke	GetWindowRect,[a_hdlg],offset rect1
	mov	eax,[rect1.right]
	mov	edx,[rect1.bottom]
	sub	eax,[rect1.left]
	sub	edx,[rect1.top]
	mov	[chat_dlg_min_dx],eax
	mov	[chat_dlg_min_dy],edx
	
	
;memo initial pos of controls, to use when dlg is resized
	invoke	GetDlgItem,[a_hdlg],IDC_CHAT_EDIT_LOG
	invoke	GetWindowRect,eax,offset rect2
	mov	eax,[rect2.right]
	mov	edx,[rect2.bottom]
	sub	eax,[rect2.left]
	sub	edx,[rect2.top]
	mov	[chat_dlg_edit_log_dx],eax
	mov	[chat_dlg_edit_log_dy],edx
	invoke	ScreenToClient,[a_hdlg],offset rect2
	mov	eax,[rect2.left]		;convert top-left point in client coords
	mov	edx,[rect2.top]
	mov	[chat_dlg_edit_log_x],eax	;relative to dialog
	mov	[chat_dlg_edit_log_y],edx
	
	invoke	GetDlgItem,[a_hdlg],IDC_CHAT_EDIT_MSG
	invoke	GetWindowRect,eax,offset rect2
	mov	eax,[rect2.right]
	mov	edx,[rect2.bottom]
	sub	eax,[rect2.left]
	sub	edx,[rect2.top]
	mov	[chat_dlg_edit_msg_dx],eax
	mov	[chat_dlg_edit_msg_dy],edx
	invoke	ScreenToClient,[a_hdlg],offset rect2
	mov	eax,[rect2.left]		;convert top-left point in client coords
	mov	edx,[rect2.top]
	mov	[chat_dlg_edit_msg_x],eax	;relative to dialog
	mov	[chat_dlg_edit_msg_y],edx
	
	invoke	GetDlgItem,[a_hdlg],IDC_CHAT_BTN_TALK
	invoke	GetWindowRect,eax,offset rect2
	mov	eax,[rect2.right]
	mov	edx,[rect2.bottom]
	sub	eax,[rect2.left]
	sub	edx,[rect2.top]
	mov	[chat_dlg_btn_talk_dx],eax
	mov	[chat_dlg_btn_talk_dy],edx
	invoke	ScreenToClient,[a_hdlg],offset rect2
	mov	eax,[rect2.left]		;convert top-left point in client coords
	mov	edx,[rect2.top]
	mov	[chat_dlg_btn_talk_x],eax	;relative to dialog
	mov	[chat_dlg_btn_talk_y],edx
	
	
@@end_init:
	mov	eax,1
ret

@@command:
	cmp	[a_lparam],0
	jnz	@@controls
	
	xor	eax,eax
ret
;-------------------------------------------------
; handle dialog controls
;-------------------------------------------------
@@controls:
	mov	eax,[a_wparam]
	
	.IF	eax==IDC_CHAT_BTN_TALK
		
		
	;copy user name
		invoke	Str_Copy,[username_psz],[send_buff_psz]
		add	eax,[send_buff_psz]
		mov	BYTE PTR [eax],":"
		inc	eax
		mov	BYTE PTR [eax],0
		mov	[l_psz],eax
		
	;copy string from edit box
		invoke	GetDlgItem,[a_hdlg],IDC_CHAT_EDIT_MSG
		mov	[l_hedit_msg],eax
		
		invoke	GetWindowText,[l_hedit_msg],[l_psz],NET_BUFF_SIZE	;out: eax=str len
		add	eax,[l_psz]
		mov	[l_psz],eax
		
	;add cr+lf - only if not already present?
		
		.IF	WORD PTR [eax]!=0a0dh
			mov	WORD PTR [eax],0a0dh
			mov	BYTE PTR [eax+2],0			;terminating zero
			add	eax,2					;update str size
		.ENDIF
		inc	eax						;add terminating zero to string size
		mov	[l_psz],eax
		
		sub	eax,[send_buff_psz]				;compute size
		mov	[l_msg_len],eax
		
		invoke	send,[hsocket],[send_buff_psz],[l_msg_len],0
		.IF	eax==SOCKET_ERROR
			call	WSAGetLastError
			.IF	eax!=WSAEWOULDBLOCK
				mNet_OutSVD eax,"Chat_Dlg_Callback-Talk: error sending="
				jmp	@@end_talk
			.ELSE
				mNet_OS "Chat_Dlg_Callback-Talk: sending later.."
			.ENDIF
		.ELSE
			mNet_OS "Chat_Dlg_Callback-Talk: send OK"
		.ENDIF
		
	;clear editbox
		mov	eax,[psz1]
		mov	BYTE PTR [eax],0
		invoke	SetWindowText,[l_hedit_msg],[psz1]
		
	;add it to local log
		invoke	GetDlgItem,[a_hdlg],IDC_CHAT_EDIT_LOG
		invoke	Chat_Dlg_Add_To_Log,eax,[send_buff_psz],[l_msg_len]
		
	@@end_talk:
		
		
	;set focus to msg edit
		invoke	GetDlgItem,[a_hdlg],IDC_CHAT_EDIT_MSG
		invoke	SetFocus,eax
		
	.ENDIF
	
	xor	eax,eax
ret

@@key_up:
	mov	eax,[a_wparam]
	.IF	eax==VK_RETURN
		xor	eax,eax
	.ENDIF
xor	eax,eax
ret


;--------------------------------
; network processing
;--------------------------------
@@network:
	
	invoke	Chat_Dlg_Network_Handle,[a_hdlg],[a_lparam]
	
	
ret


Chat_Dlg_Callback ENDP



;--------------------------------------------------------
; add a text to log editbox
;--------------------------------------------------------
Chat_Dlg_Add_To_Log PROC a_hedit,a_psz,a_sz_len:DWORD
	LOCAL	l_hedit_log,l_log_len,l_msg_len,l_p:DWORD
	
	mov	[l_hedit_log],eax
	
	invoke	GetWindowTextLength,[l_hedit_log]
	mov	[l_log_len],eax
	add	eax,[a_sz_len]
	.IF	eax<256
		mov	eax,256
	.ENDIF
	invoke	GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,eax
	mov	[l_p],eax
	
	mov	eax,[l_log_len]
	inc	eax		;must copy a null byte also
	invoke	GetWindowText,[l_hedit_log],[l_p],eax
	
	add	eax,[l_p]
	invoke	Str_Copy,[a_psz],eax
	
	invoke	SetWindowText,[l_hedit_log],[l_p]
	
	invoke	GlobalFree,[l_p]
	
	
;scroll the edit down
	invoke	SendMessage,[a_hedit],EM_GETLINECOUNT,0,0
	invoke	SendMessage,[a_hedit],EM_LINESCROLL,0,eax
	
ret
Chat_Dlg_Add_To_Log ENDP

;--------------------------------------------------
; all network handling during chat is done here
;--------------------------------------------------
Chat_Dlg_Network_Handle PROC a_hdlg,a_lparam:DWORD
	
;check for errors first
	mov	eax,[a_lparam]
	
	
	test	eax,0ffff0000h
	.IF	!ZERO?
		mNet_OS "error"
		
	.ELSE
		and	eax,0ffffh
		mNet_OutSVD eax,"event="
		
		
		test	eax,FD_CONNECT
		.IF	!ZERO?
			mNet_OS "Chat_Dlg_Callback: fd_connect"
		.ENDIF
		
		test	eax,FD_ACCEPT
		.IF	!ZERO?
			mNet_OS "Chat_Dlg_Callback: fd_accept"
		.ENDIF
		
		test	eax,FD_CLOSE
		.IF	!ZERO?
			call	Net_Close_Sockets
			invoke	EndDialog,[a_hdlg],0
			ret
		.ENDIF
		
		test	eax,FD_READ
		.IF	!ZERO?
			
			invoke	recv,[hsocket],[recv_buff_psz],NET_BUFF_SIZE,0
			.IF	eax==SOCKET_ERROR
				call	WSAGetLastError
				.IF	eax!=WSAEWOULDBLOCK
					mNet_OutSVD eax,"Chat_Dlg_Callback-FD_READ: error reading="
					jmp	@@failed_read
				.ELSE
					mNet_OS "Chat_Dlg_Callback-FD_READ: reading later.."
					jmp	@@failed_read
				.ENDIF
			.ELSE
				mNet_OS "Chat_Dlg_Callback-FD_READ: read OK"
			.ENDIF
			mov	ebx,eax		;memo bytes received
			
		;add to log window
			invoke	GetDlgItem,[a_hdlg],IDC_CHAT_EDIT_LOG
			invoke	Chat_Dlg_Add_To_Log,eax,[recv_buff_psz],ebx
			
		@@failed_read:
			
		;reenable all notifications (FD_READ would be disabled if we didnt set it again)
			invoke	WSAAsyncSelect,[hsocket],[a_hdlg],WM_MY_NET_MSG,\
					FD_ACCEPT + FD_CONNECT + FD_CLOSE + FD_READ + FD_WRITE
			
		;flash and beep if not active 
			call	GetForegroundWindow
			.IF	eax!=[a_hdlg]
				invoke	FlashWindow,[a_hdlg],1
				invoke	PlaySound,[snd_msg_p],NULL,SND_ASYNC or SND_MEMORY or SND_NOSTOP
			.ENDIF
			
			
		.ENDIF
		
		test	eax,FD_WRITE
		.IF	!ZERO?
			mNet_OS "Chat_Dlg_Callback: write"
		.ENDIF
			
	.ENDIF

ret
Chat_Dlg_Network_Handle ENDP

