
;possible results of dlg
CONNECTING_DLG_RESULT_SUCCES	EQU	0
CONNECTING_DLG_RESULT_ABORT	EQU	1

.CODE

Connecting_Dlg_Network_Handle PROTO :DWORD,:DWORD


Connecting_Dlg_Callback PROC USES EBX EDI ESI EBP a_hdlg,a_msg,a_wparam,a_lparam:DWORD
	LOCAL	l_psz:DWORD
	LOCAL	l_sz_val[16]:BYTE
	
	mov	eax,[a_msg]
	
	cmp	eax,WM_CLOSE
	jz	@@close
	cmp	eax,WM_COMMAND
	jz	@@command
	cmp	eax,WM_INITDIALOG
	jz	@@init
	
	cmp	eax,WM_MY_NET_MSG
	jz	@@network
	
	xor	eax,eax
ret

@@close:
	call	Net_Close_Sockets
	invoke	EndDialog,[a_hdlg],CONNECTING_DLG_RESULT_ABORT
ret

@@init:
	
	.IF	[online_mode]==ONLINE_HOST
		invoke	Str_Copy,mSZ("Waiting remote connection as ",0ah,0dh),[psz1]
	.ELSE
		invoke	Str_Copy,mSZ("Connecting as ",0ah,0dh),[psz1]
	.ENDIF
	add	eax,[psz1]
	mov	[l_psz],eax
	
;add user name
	invoke	Str_Copy,[username_psz],[l_psz]
	add	[l_psz],eax
;add port
	invoke	Str_Copy,mSZ(" on port "),[l_psz]
	add	[l_psz],eax
	
	invoke	DWtoAscii,[port],addr l_sz_val,FMT_LD
	invoke	Str_Copy,addr l_sz_val,[l_psz]
	
	invoke	GetDlgItem,[a_hdlg],IDC_CONN_LBL_DESC
	invoke	SetWindowText,eax,[psz1]
	
	.IF	[online_mode]==ONLINE_HOST
		invoke	Net_Setup_Server,[a_hdlg]
	.ELSE
		invoke	Net_Setup_Client,[a_hdlg]
	.ENDIF
	
	xor	eax,eax	
ret

@@command:
	cmp	[a_lparam],0
	jnz	@@controls
	
	xor	eax,eax
ret
;-------------------------------------------------
; handle dialog controls
;-------------------------------------------------
@@controls:
	mov	eax,[a_wparam]
	
	.IF	eax==IDC_CONN_BTN_ABORT
		call	Net_Close_Sockets
		invoke	EndDialog,[a_hdlg],CONNECTING_DLG_RESULT_ABORT
	.ENDIF
	
	xor	eax,eax
ret

;--------------------------------
; network processing
;--------------------------------
@@network:
	invoke	Connecting_Dlg_Network_Handle,[a_hdlg],[a_lparam]
	
ret

Connecting_Dlg_Callback ENDP



Connecting_Dlg_Network_Handle PROC a_hdlg,a_lparam:DWORD
	
;check for errors first
	mov	eax,[a_lparam]
	
	test	eax,0ffff0000h
	.IF	!ZERO?	;-------------------------- ERROR events --------------------------------
		mov	edx,eax
		and	edx,0ffffh
		.IF	edx==FD_CONNECT
			shr	eax,16
			.IF	eax==WSAECONNREFUSED
				mNet_OS "Connecting_Dlg_Callback: Connection refused"
				invoke	MessageBox,[a_hdlg],
					mSZ("Connection refused. Make sure the host has started Chat application."),
					mSZ("CONNECTION ERROR"),MB_RETRYCANCEL
				.IF	eax==IDRETRY
					mNet_OS "Connection refused - retrying.."
					invoke	connect,[hsocket],offset socket_addr,SIZE socket_addr
					.IF	eax==SOCKET_ERROR
						call	WSAGetLastError
						mNet_OutSVD eax,"Connecting_Dlg_Callback: connect error, res="
						.IF	eax==WSAEWOULDBLOCK				;ignore it, because we are working async
							mNet_OS "Connecting_Dlg_Callback: ignored error, WSAEWOULDBLOCK"
						.ELSE
							ret
						.ENDIF
					.ELSE
						mNet_OS "Connecting_Dlg_Callback: connect success"
					.ENDIF
					
				.ELSE	;cancel
					mNet_OS "Connection refused - cancel"
					invoke	EndDialog,[a_hdlg],CONNECTING_DLG_RESULT_ABORT
				.ENDIF
			.ELSEIF	eax==WSAETIMEDOUT
				mNet_OS "Connecting_Dlg_Callback: Connection timed out"
				invoke	MessageBox,[a_hdlg],
					mSZ("Connection timed out. Make sure the host is reachable/online and the firewall is allowing in/out on this app."),
					mSZ("CONNECTION ERROR"),MB_RETRYCANCEL
				.IF	eax==IDRETRY
					mNet_OS "Connection timed out - retrying.."
					invoke	connect,[hsocket],offset socket_addr,SIZE socket_addr
					.IF	eax==SOCKET_ERROR
						call	WSAGetLastError
						mNet_OutSVD eax,"Connecting_Dlg_Callback: connect error, res="
						.IF	eax==WSAEWOULDBLOCK				;ignore it, because we are working async
							mNet_OS "Connecting_Dlg_Callback: ignored error, WSAEWOULDBLOCK"
						.ELSE
							ret
						.ENDIF
					.ELSE
						mNet_OS "Connecting_Dlg_Callback: connect success"
					.ENDIF
					
				.ELSE	;cancel
					mNet_OS "Connection timed out - cancel"
					invoke	EndDialog,[a_hdlg],CONNECTING_DLG_RESULT_ABORT
				.ENDIF
				
			.ELSE
				mNet_OutSVD eax,"Connecting_Dlg_Callback: CONNECT error="
				
				
			.ENDIF
			jmp	@@end_err
		.ENDIF
		
		shr	eax,16
		mNet_OutSVD eax,"Connecting_Dlg_Callback: unprocessed error="
		mNet_OutSVD edx,"Connecting_Dlg_Callback: for event="
	@@end_err:
		
	.ELSE	;-------------------------- normal events --------------------------------
		and	eax,0ffffh
		
		test	eax,FD_CONNECT
		.IF	!ZERO?
			mNet_OS "Connecting_Dlg_Callback: connect succes"
			
			invoke	WSAAsyncSelect,[hsocket],[a_hdlg],0,0
			invoke	EndDialog,[a_hdlg],CONNECTING_DLG_RESULT_SUCCES
			
			jmp	@@end_events
		.ENDIF
		
		test	eax,FD_ACCEPT
		.IF	!ZERO?
			
			invoke	accept,[hsocket_server],0,0
			mov	[hsocket_remote],eax
			mov	[hsocket],eax				;becames current working socket
			.IF	eax==INVALID_SOCKET
				invoke	WSAGetLastError
				mNet_OutSVD eax,"Connecting_Dlg_Callback: failed accept, err="
				ret
			.ENDIF
			
			mNet_OS "Connecting_Dlg_Callback: accept succes"
			
		;remove old notifications
			invoke	WSAAsyncSelect,[hsocket_server],[a_hdlg],0,0
			
			invoke	EndDialog,[a_hdlg],CONNECTING_DLG_RESULT_SUCCES
			jmp	@@end_events
		.ENDIF
		
		test	eax,FD_CLOSE
		.IF	!ZERO?
			mNet_OS "Connecting_Dlg_Callback: close"
			invoke	EndDialog,[a_hdlg],CONNECTING_DLG_RESULT_ABORT
			jmp	@@end_events
		.ENDIF
		
		mNet_OutSVD eax,"Connecting_Dlg_Callback: unprocessed event="
		
	@@end_events:
	.ENDIF
	
	
	
ret
Connecting_Dlg_Network_Handle ENDP
