
;possible results of dlg
ONLINE_DLG_RESULT_HOST		EQU	0
ONLINE_DLG_RESULT_REMOTE	EQU	1
ONLINE_DLG_RESULT_EXIT		EQU	-1

.CODE
Online_Dlg_Update_Controls PROTO a_hdlg:DWORD

Online_Dlg_Callback PROC USES EBX EDI ESI EBP a_hdlg,a_msg,a_wparam,a_lparam:DWORD
	LOCAL	l_hedit:DWORD
	LOCAL	l_username_size:DWORD
	
	mov	eax,[a_msg]
	
	cmp	eax,WM_CLOSE
	jz	@@close
	cmp	eax,WM_INITDIALOG
	jz	@@init
	cmp	eax,WM_COMMAND
	jz	@@command
	cmp	eax,WM_ERASEBKGND
	jz	@@erase_bg
	cmp	eax,WM_PAINT
	jz	@@paint
	cmp	eax,WM_NCPAINT
	jz	@@paint
	cmp	eax,WM_KEYUP
	jz	@@key_up
	
	xor	eax,eax
ret


@@paint:
;invoke	BeginPaint,[a_hdlg],offset ps
;invoke	EndPaint,[a_hdlg],offset ps
	xor	eax,eax				;return we processed the msg
ret

@@erase_bg:
;	or	eax,1				;mark we processed the msg
	xor	eax,eax
ret

@@close:
	invoke	EndDialog,[a_hdlg],ONLINE_DLG_RESULT_EXIT
ret


;-----------------------------------------------------
;
; initialize the dialog:
; -set radio btn
;-----------------------------------------------------

@@init:
	
;set checked radion btn from  current state
	.IF	[online_mode]==ONLINE_HOST
		mov	eax,IDC_ONLINE_RADBTN_HOST
	.ELSE
		mov	eax,IDC_ONLINE_RADBTN_REMOTE
	.endif
	invoke	GetDlgItem,[a_hdlg],eax
	invoke	SendMessage,eax,BM_SETCHECK,BST_CHECKED,0
	
	
;set focus to edit control
	invoke	GetDlgItem,[a_hdlg],IDC_ONLINE_EDIT_NAME
	mov	[l_hedit],eax
	
	invoke	SetFocus,[l_hedit]
	
;set user name default to computer name
	mov	[l_username_size],USER_NAME_MAXSIZE
	invoke	GetUserName,[username_psz],addr l_username_size
	.IF	eax==0	;failed
		invoke	Str_Copy,offset username_sz_default,[username_psz]
	.ENDIF
	invoke	SetWindowText,[l_hedit],[username_psz]
	
;set port edit to its value
	invoke	DWtoAscii,[port],[psz1],FMT_LD
	invoke	GetDlgItem,[a_hdlg],IDC_ONLINE_EDIT_PORT
	invoke	SetWindowText,eax,[psz1]
	
;set IP
	invoke	GetDlgItem,[a_hdlg],IDC_ONLINE_IPA_HOST
	invoke	SendMessage,eax,IPM_SETADDRESS,0,[ip]
	
	invoke	Online_Dlg_Update_Controls,[a_hdlg]
	
	xor	eax,eax					;prevent windows from setting default focus
ret

@@command:
	cmp	[a_lparam],0
	jnz	@@controls
	
	xor	eax,eax
ret
;-------------------------------------------------
; handle dialog controls
;-------------------------------------------------
@@controls:
	mov	eax,[a_wparam]
	
	.IF	eax==IDC_ONLINE_BTN_EXIT
		invoke	EndDialog,[a_hdlg],ONLINE_DLG_RESULT_EXIT
		
	.ELSEIF	eax==IDC_ONLINE_BTN_CONTINUE
		
	;get user name
		invoke	GetDlgItem,[a_hdlg],IDC_ONLINE_EDIT_NAME
		invoke	GetWindowText,eax,[username_psz],USER_NAME_MAXSIZE
		
	;get ip
		.IF	[online_mode]==ONLINE_REMOTE
			invoke	GetDlgItem,[a_hdlg],IDC_ONLINE_IPA_HOST
			invoke	SendMessage,eax,IPM_GETADDRESS,0,offset ip
		.ENDIF
		
	;get port
		invoke	GetDlgItemInt,[a_hdlg],IDC_ONLINE_EDIT_PORT,0,0
		mov	[port],eax
mNet_OutSVD eax,"port="		
		mov	eax,[online_mode]
		invoke	EndDialog,[a_hdlg],eax
		
	.ELSEIF	eax==IDC_ONLINE_RADBTN_HOST
		
		invoke	SendMessage,[a_lparam],BM_GETCHECK,0,0
		.IF	eax==1
			mov	[online_mode],ONLINE_DLG_RESULT_HOST
		.ENDIF
		
		invoke	Online_Dlg_Update_Controls,[a_hdlg]
	.ELSEIF	eax==IDC_ONLINE_RADBTN_REMOTE
		invoke	SendMessage,[a_lparam],BM_GETCHECK,0,0
		.IF	eax==1
			mov	[online_mode],ONLINE_DLG_RESULT_REMOTE
		.ENDIF
		
		invoke	Online_Dlg_Update_Controls,[a_hdlg]
		
	.ELSEIF	eax==IDC_ONLINE_EDIT_PORT
	;	mOS "port"
	.ENDIF
	
;none
	xor	eax,eax
ret

@@key_up:
	mov	eax,[a_wparam]
	.IF	eax==VK_RETURN
		xor	eax,eax
	.ENDIF
xor	eax,eax
ret

Online_Dlg_Callback ENDP

Online_Dlg_Update_Controls PROC a_hdlg:DWORD
	LOCAL	l_ctrl:DWORD
	
	.IF	[online_mode]==ONLINE_HOST
		
		invoke	GetDlgItem,[a_hdlg],IDC_ONLINE_IPA_HOST
		invoke	EnableWindow,eax,0
		invoke	GetDlgItem,[a_hdlg],IDC_ONLINE_STAT_HOST_IP
		invoke	EnableWindow,eax,0
		
	.ELSE
		
		invoke	GetDlgItem,[a_hdlg],IDC_ONLINE_IPA_HOST
		invoke	EnableWindow,eax,1
		invoke	GetDlgItem,[a_hdlg],IDC_ONLINE_STAT_HOST_IP
		invoke	EnableWindow,eax,1
		
	.ENDIF
	
	
ret
Online_Dlg_Update_Controls ENDP
