;==========================================================================
;
; Everything that deals with network
;
;==========================================================================
.DATA?
	wsa_data	WSADATA	<?>
	
	socket_addr	sockaddr_in	<?>
	
NET_BUFF_SIZE	EQU	16*1024
	recv_buff_psz	dd	?
	send_buff_psz	dd	?
.DATA
	ws_init		dd	0
	hsocket		dd	INVALID_SOCKET
	hsocket_remote	dd	INVALID_SOCKET	;for server mode, socket of remote client - becames working socket after connection
	hsocket_server	dd	INVALID_SOCKET	;for server mode, socket of host - is working socket UNTIL connection

	sz_host_dbg	db	"HOST - ",0
	sz_client_dbg	db	"CLIENT - ",0
	sz_host		db	"Host",0
	sz_client	db	"Client",0
.CODE

PORT_DEFAULT	EQU	10000
IP_DEFAULT	EQU	(127 SHL 24) OR 1	;127.0.0.1

WM_MY_NET_MSG	EQU	WM_USER + 200

FD_READ				equ 1 SHL 0
FD_WRITE			equ 1 SHL 1
FD_OOB				equ 1 SHL 2
FD_ACCEPT			equ 1 SHL 3
FD_CONNECT			equ 1 SHL 4
FD_CLOSE			equ 1 SHL 5
FD_QOS				equ 1 SHL 6
FD_GROUP_QOS			equ 1 SHL 7
FD_ROUTING_INTERFACE_CHANGE	equ 1 SHL 8
FD_ADDRESS_LIST_CHANGE		equ 1 SHL 9

FD_ALL_EVENTS			equ FD_READ+FD_WRITE+FD_OOB+FD_ACCEPT+FD_CONNECT+FD_CLOSE+FD_QOS+FD_GROUP_QOS+FD_ROUTING_INTERFACE_CHANGE+FD_ADDRESS_LIST_CHANGE



mNet_OutSVD MACRO a_val_dec,a_sz:VARARG
	LOCAL sz,sz_val
IFDEF	DEBUG_BUILD
.DATA
	sz	db	a_sz
	sz_val	db	10 dup (0)
.CODE
	pushad
	invoke	DWtoAscii,a_val_dec,offset sz_val,FMT_LD
	.IF	[online_mode]==ONLINE_HOST
		mov	eax,offset sz_host_dbg
	.ELSE
		mov	eax,offset sz_client_dbg
	.ENDIF
	invoke	Str_Copy,eax,[psz1]
	add	eax,[psz1]
	invoke	Str_Copy,offset sz,eax
	invoke	OutputDebugString,[psz1]
	popad
ENDIF
ENDM


mNet_OS MACRO a_sz:VARARG
	LOCAL sz,sz_val
IFDEF	DEBUG_BUILD
.DATA
	sz	db	a_sz,0
.CODE
	pushad
	.IF	[online_mode]==ONLINE_HOST
		mov	eax,offset sz_host_dbg
	.ELSE
		mov	eax,offset sz_client_dbg
	.ENDIF
	invoke	Str_Copy,eax,[psz1]
	add	eax,[psz1]
	invoke	Str_Copy,offset sz,eax
	invoke	OutputDebugString,[psz1]
	popad
ENDIF
ENDM






Net_Init PROC
	
	mov	[ws_init],0
	
;------------------------
;initialize winsock
;------------------------
	invoke	WSAStartup,0002h,offset wsa_data
	.IF	eax!=0
		mOutSVD eax,"WSAStartup failed, err="
		ret
	.ENDIF
	
	movzx	eax,[wsa_data.wVersion]
	cmp	eax,0002h
	.IF	SIGN?
		mOutSVD eax,"WSAStartup version too low ="
		call	WSACleanup
		
		ret
	.ENDIF
	mOutSVD eax,"winsock version="
	mov	[ws_init],1
	
	
ret
Net_Init ENDP

Net_Setup_Server PROC a_hwnd:DWORD
	
	
;------------------------
; create a socket
;------------------------
	invoke	socket,AF_INET,SOCK_STREAM,IPPROTO_TCP
	mov	[hsocket],eax
	.IF	eax==INVALID_SOCKET
		call	WSAGetLastError
		mOutSVD eax,"Net_Setup_Server: failed to create socket, err="
		ret
	.ENDIF
	mNet_OS "Net_Setup_Server: Socket created"
	
	mov	eax,[hsocket]
	mov	[hsocket_server],eax		;save it as server socket
	
	
;setup structure
	mSet_Memb <offset socket_addr>,SIZE socket_addr,0
	
	mov	[socket_addr.sin_family],AF_INET
	
	mov	eax,[port]
	xchg	al,ah				;LittleEndian to BigEndian
	mov	[socket_addr.sin_port],ax
	
	mov	[socket_addr.sin_addr],INADDR_ANY
	
	invoke	bind,[hsocket],offset socket_addr,SIZE socket_addr
	.IF	eax==SOCKET_ERROR
		call	WSAGetLastError
		mNet_OutSVD eax,"Net_Setup_Server: bind error, res="
		ret
	.ENDIF
	mNet_OS "Net_Setup_Server: bind succes"
	
	
	invoke	WSAAsyncSelect,[hsocket],[a_hwnd],WM_MY_NET_MSG,\
			FD_ACCEPT + FD_CONNECT + FD_CLOSE ;+ FD_READ + FD_WRITE
	.IF	eax==SOCKET_ERROR
		call	WSAGetLastError
		mNet_OutSVD eax,"Net_Setup_Server: WSAAsyncSelect error="
		ret
	.ENDIF
	mNet_OS "Net_Setup_Server: WSAAsyncSelect succes"
	
	
	invoke	listen,[hsocket],1	;1 conection max
	.IF	eax==SOCKET_ERROR
		call	WSAGetLastError
		mNet_OutSVD eax,"Net_Setup_Server: listen error="
		ret
	.ENDIF
	mNet_OS "Net_Setup_Server: listen succes"
	
	
ret
Net_Setup_Server ENDP

Net_Setup_Client PROC a_hwnd:DWORD
	
;------------------------
; create a socket
;------------------------
	invoke	socket,AF_INET,SOCK_STREAM,IPPROTO_TCP
	mov	[hsocket],eax
	.IF	eax==INVALID_SOCKET
		call	WSAGetLastError
		mOutSVD eax,"Net_Setup_Client: failed to create socket, err="
		ret
	.ENDIF
	mNet_OS "Net_Setup_Client: Socket created"
	
;setup structure
	mSet_Memb <offset socket_addr>,SIZE socket_addr,0
	
	mov	[socket_addr.sin_family],AF_INET
	
	mov	eax,[port]
	xchg	al,ah				;LittleEndian to BigEndian
	mov	[socket_addr.sin_port],ax
	
	mov	eax,[ip]			;set on "online" connect dialog
	bswap	eax
	mov	[socket_addr.sin_addr],eax
	
	
	
	invoke	WSAAsyncSelect,[hsocket],[a_hwnd],WM_MY_NET_MSG,\
			FD_ACCEPT + FD_CONNECT + FD_CLOSE ;+ FD_READ + FD_WRITE
	.IF	eax==SOCKET_ERROR
		call	WSAGetLastError
		mNet_OutSVD eax,"Net_Setup_Client: WSAAsyncSelect error="
		ret
	.ENDIF
	mNet_OS "Net_Setup_Client: WSAAsyncSelect succes"
	
	
	invoke	connect,[hsocket],offset socket_addr,SIZE socket_addr
	.IF	eax==SOCKET_ERROR
		call	WSAGetLastError
		mNet_OutSVD eax,"Net_Setup_Client: connect error, res="
		.IF	eax==WSAEWOULDBLOCK				;ignore it, because we are working async
			mNet_OS "Net_Setup_Client: ignored error, WSAEWOULDBLOCK"
		.ELSE
			ret
		.ENDIF
	.ELSE
		mNet_OS "Net_Setup_Client: connect succes"
	.ENDIF
	
	
	
	
ret
Net_Setup_Client ENDP


Net_Cleanup PROC
	
	.IF	[hsocket]!=INVALID_SOCKET
		invoke	closesocket,[hsocket]
		mov	[hsocket],INVALID_SOCKET
	.ENDIF
	
	.IF	[ws_init]==1
		call	WSACleanup
		mov	[ws_init],0
	.ENDIF
	
ret
Net_Cleanup ENDP


Net_Close_Sockets PROC
	
	invoke	closesocket,[hsocket]
	.IF	eax==SOCKET_ERROR
		.IF	eax!=WSAEWOULDBLOCK
			mNet_OutSVD eax,"Chat_Dlg_Close: error closing="
			jmp	@@failed_close
		.ELSE
			mNet_OS "Chat_Dlg_Close: closing later.."
			jmp	@@failed_close
		.ENDIF
	.ENDIF
	
	mNet_OS "Chat_Dlg_Close: close OK"
	
	mov	[hsocket],INVALID_SOCKET
	
	.IF	[online_mode]==ONLINE_HOST && [hsocket_server]!=INVALID_SOCKET	;close server socket also
		invoke	closesocket,[hsocket_server]
		.IF	eax==SOCKET_ERROR
			mNet_OutSVD eax,"Chat_Dlg_Close: error closing server socket="
		.ELSE
			mNet_OS "Chat_Dlg_Close: closed server socket OK"
		.ENDIF
	.ENDIF
	
	
@@failed_close:
	
	
ret
Net_Close_Sockets ENDP


;-------------------------------------------
; Little Endian <--> Big Endian conversions
; uses eax !
;-------------------------------------------
mLEtoBE16 macro a_val16
	mov	ax,a_val16
	xchg	al,ah
ENDM

